import Vue from 'vue'
import Vuex from 'vuex'

import state from '@/store/state'
import getters from '@/store/getters'
import actions from '@/store/actions'
import mutations from '@/store/mutations'
// Modules
import partners from '@/store/modules/partners'
import loader from '@/store/modules/loader'

Vue.use(Vuex)

const Store = new Vuex.Store({
    state,
    getters,
    mutations,
    actions,
    modules:{
        partners,
        loader
    }
})

export default Store
