const state = {
    partners: [],
    filtered: [],
    selectedPartnerInvoices: [],
    selectedPartner: null
}

const getters ={
    partners(state){
        return state.filtered.length === 0 ? state.partners : state.filtered
    },
    hasSelectedPartner(state){
        return !!state.selectedPartner
    },
    selectedPartner(state){
        return state.selectedPartner
    },
    partnerInvoices(state){
        return state.selectedPartnerInvoices
    },
    partnerMoveLine(state){
        let moveline= []
        state.selectedPartnerInvoices.forEach(item =>{
            moveline.push(item.movelines);
        })
        return  !! moveline ? moveline : []
    }
}

const mutations ={
    pushPartners(state, payload){
        state.partners =[ ...payload.partners]
    },
    selectPartner(state, payload){
        state.selectedPartner = payload.partner
    },
    selectPartnerInvoices(state, payload){
        state.selectedPartnerInvoices = state.selectedPartner.invoices
    },
    applyPartnersFilter(state, payload){
        state.filtered = payload
    }
}

const actions ={
    fetchPartners({ commit, dispatch }){
        return new Promise((resolve, reject) => {
            let ResPartner = new openerp.web.Model('res.partner')

            ResPartner.call('get_partners',{
                context: new openerp.web.CompoundContext()
            }).then(response => {
                commit('pushPartners',{
                    partners: response
                })

                dispatch('loaded', 'partners')

                resolve()
            }).fail(error => {
                console.log(error)
                reject(error)
            })
        })
    },
    selectPartner({ commit }, payload){
        commit('selectPartner',{
            partner: payload
        })
        commit('selectPartnerInvoices')
    },
    filterCustomers({ commit },payload){
        commit('applyPartnersFilter', payload)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
